Index: /trunk/src/org/expeditee/gui/Frame.java
===================================================================
--- /trunk/src/org/expeditee/gui/Frame.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Frame.java	(revision 1102)
@@ -2312,40 +2419,47 @@
 	}
 
-	public void parse() {
+	public void parse()
+	{
 		for (Overlay o : getOverlays()) {
 			o.Frame.parse();
 		}
+		
 		// Must parse the frame AFTER the overlays
 		FrameUtils.Parse(this);
 	}
 
-	public void setPath(String path) {
+	public void setPath(String path)
+	{
 		this.path = path;
 	}
 
-	public String getPath() {
+	public String getPath()
+	{
 		return path;
 	}
 
-	public void setLocal(boolean isLocal) {
+	public void setLocal(boolean isLocal)
+	{
 		this._isLocal = isLocal;
 	}
 
-	public boolean isLocal() {
+	public boolean isLocal()
+	{
 		return _isLocal;
 	}
 
-	public String getExportFileTagValue() {
+	public String getExportFileTagValue()
+	{
 		return getAnnotationValue("file");
 	}
 
-	public void assertEquals(Frame frame2) {
+	public void assertEquals(Frame frame2)
+	{
 		// Check that all the items on the frame are the same
 		List<Item> items1 = getVisibleItems();
 		List<Item> items2 = frame2.getVisibleItems();
+		
 		if (items1.size() != items2.size()) {
-			throw new UnitTestFailedException(items1.size() + " items", items2
-					.size()
-					+ " items");
+			throw new UnitTestFailedException(items1.size() + " items", items2.size() + " items");
 		} else {
 			for (int i = 0; i < items1.size(); i++) {
@@ -2361,20 +2475,19 @@
 	}
 
-	public boolean hasObservers() {
+	public boolean hasObservers()
+	{
 		return _observers != null && _observers.size() > 0;
 	}
 
-	public Collection<? extends Item> getInteractableItems() {
+	public Collection<? extends Item> getInteractableItems()
+	{
 		/*
 		 * TODO: Cache the interactableItems list so we dont have to recreate it
 		 * every time this method is called
 		 */
-		if (_interactableItems.size() > 0)
-			return _interactableItems;
+		if (_interactableItems.size() > 0) return _interactableItems;
 
 		for (Item i : _body) {
-			if (i == null) {
-				continue;
-			}
+			if (i == null) continue;
 			if (i.isVisible()) {
 				_interactableItems.add(i);
@@ -2386,6 +2499,4 @@
 				_interactableItems.add(i);	
 			}
-			
-			
 		}
 
@@ -2398,3 +2509,26 @@
 		return _interactableItems;
 	}
+
+	private static final class History {
+		
+		public enum Type {
+			deletion,
+			movement
+		}
+		
+		public final List<Item> items;
+		
+		public final Type type;
+		
+		public History(Collection<Item> items, Type type)
+		{
+			this.items = new LinkedList<Item>(items);
+			this.type = type;
+		}
+		
+		public String toString()
+		{
+			return this.type.toString() + ":\n" + this.items.toString();
+		}
+	}
 }
Index: /trunk/src/org/expeditee/gui/FrameCreator.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameCreator.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameCreator.java	(revision 1102)
@@ -19,12 +19,14 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.util.*;
+import java.util.LinkedList;
+import java.util.List;
 
 import org.expeditee.agents.ExistingFramesetException;
+import org.expeditee.core.Colour;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
 
 public class FrameCreator {
+	
 	public static final int INDENT_FROM_TITLE = 20;
 
@@ -60,5 +62,5 @@
 
 	public FrameCreator(String frameTitle) {
-		this(DisplayIO.getCurrentFrame().getFramesetName(), DisplayIO
+		this(DisplayController.getCurrentFrame().getFramesetName(), DisplayController
 				.getCurrentFrame().getPath(), frameTitle, false, false);
 	}
@@ -83,10 +85,10 @@
 	 * @return the newly created button.
 	 */
-	public static Item createButton(String text, Float x, Float y, Float right,
-			Float bottom) {
+	public static Item createButton(String text, Integer x, Integer y, Integer right,
+			Integer bottom) {
 		Text button = new Text(text);
 
-		button.setBackgroundColor(Color.LIGHT_GRAY);
-		button.setBorderColor(Color.DARK_GRAY);
+		button.setBackgroundColor(Colour.LIGHT_GREY);
+		button.setBorderColor(Colour.DARK_GREY);
 		button.setThickness(2.0F);
 		if (bottom != null)
@@ -99,19 +101,19 @@
 			button.setY(y);
 
-		button.updatePolygon();
+		button.invalidateBounds();
 
 		return button;
 	}
 
-	public FrameCreator(String name, String path, String frameTitle,
-			boolean recreate, boolean multiColumn) {
+	public FrameCreator(String name, String path, String frameTitle, boolean recreate, boolean multiColumn)
+	{
 		_multiColumn = multiColumn;
-		_Mnext = createButton("@Next", null, null, 10F, 15F);
+		_Mnext = createButton("@Next", null, null, 10, 15);
 
 		_Mprev = createButton("@Previous", null, null, _Mnext.getBoundsWidth()
-				+ _Mnext.getAnchorRight() + 20F, 15F);
+				+ _Mnext.getAnchorRight() + 20, 15);
 
 		_Mfirst = createButton("@First", null, null, _Mprev.getBoundsWidth()
-				+ _Mprev.getAnchorRight() + 20F, 15F);
+				+ _Mprev.getAnchorRight() + 20, 15);
 
 		Frame toUse = null;
@@ -180,5 +182,6 @@
 	}
 
-	private void resetGlobals(Frame toUse) {
+	private void resetGlobals(Frame toUse)
+	{
 		Text title = toUse.getTitleItem();
 		START_X = INDENT_FROM_TITLE + title.getX();
@@ -217,6 +220,5 @@
 				// new frame
 				if (!_multiColumn
-						|| toAdd.getBoundsWidth() + _lastX > FrameGraphics
-								.getMaxSize().width) {
+						|| toAdd.getBoundsWidth() + _lastX > DisplayController.getFramePaintArea().getWidth()) {
 					// Make sure text items that are created on the current
 					// frame are removed
@@ -229,5 +231,5 @@
 			toAdd.setOffset(0, 0);
 			toAdd.setID(_current.getNextItemID());
-			toAdd.setRightMargin(FrameGraphics.getMaxFrameSize().width, true);
+			toAdd.setRightMargin(DisplayController.getFramePaintArea().getWidth(), true);
 
 			_current.addItem(toAdd);
@@ -245,5 +247,5 @@
 	}
 
-	public Text addText(String toAdd, Color c, String link, String action,
+	public Text addText(String toAdd, Colour c, String link, String action,
 			boolean bSave) {
 		Text text = _current.createNewText(toAdd);
